<template>
  <div>
    <b-icon-trash
      @click="modalShow = !modalShow"
      v-show="me && me.groups.includes('MOD')"
    />
    <b-modal
      v-model="modalShow"
      id="delete-property-modal"
      :title="`Delete ${this.property.name}`"
      @ok="submit"
      ok-variant="danger"
    >
      <p>
        Are you sure you want to permanently delete <b>{{ property.name }}</b
        >?
      </p>
      <p>This <b>can not</b> be undone!</p>
    </b-modal>
  </div>
</template>

<script>
import gql from "graphql-tag";

export default {
  name: "DeleteProperty",
  data() {
    return {
      modalShow: false,
      me: {
        groups: []
      },
      error: "",
      name: "",
      description: ""
    };
  },
  apollo: {
    me: {
      query: gql`
        query {
          me {
            id
            name
            groups
            email
            joined
          }
        }
      `
    }
  },
  props: {
    property: Object
  },
  methods: {
    submit(e) {
      e.preventDefault();
      this.$apollo
        .mutate({
          mutation: gql`
            mutation($id: ID!) {
              deleteProperty(id: $id) {
                id
              }
            }
          `,
          variables: {
            id: this.property.id
          }
        })
        .then(() => location.reload())
        .catch(error => {
          this.error = error;
        });
    }
  }
};
</script>
